VERSION 5.00
Begin VB.Form frmKeyValues 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "GEMUS ""key=value"" pairs"
   ClientHeight    =   5295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8775
   Icon            =   "frmKeyValues.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5295
   ScaleWidth      =   8775
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtPairs 
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4095
      Left            =   120
      MaxLength       =   65526
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   480
      Width           =   8535
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   7560
      TabIndex        =   3
      Top             =   4800
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Height          =   375
      Left            =   6360
      TabIndex        =   2
      Top             =   4800
      Width           =   1095
   End
   Begin VB.Label lblName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Game Name goes here!"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   120
      MouseIcon       =   "frmKeyValues.frx":08CA
      MousePointer    =   99  'Custom
      TabIndex        =   0
      Top             =   120
      UseMnemonic     =   0   'False
      Width           =   2475
   End
End
Attribute VB_Name = "frmKeyValues"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'==============================================
'              == GameBase ==
'    The Universal Retro-Gaming Frontend
'           and Database Utility
'----------------------------------------------
' Copyright (C) 1997-2004 James Burrows
' Email: gamebase@itsa.me.uk
' Homepage: http://www.bu22.com/
'----------------------------------------------
' This program is free software; you can
' redistribute it and/or modify it under the
' terms of the GNU General Public License as
' published by the Free Software Foundation;
' either version 2 of the License, or (at your
' option) any later version.
'
' This program is distributed in the hope that
' it will be useful, but WITHOUT ANY WARRANTY;
' without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR
' PURPOSE. See the GNU General Public License
' for more details.
'
' You should have received a copy of the GNU
' General Public License along with this
' program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330,
' Boston, MA 02111-1307 USA
'==============================================

Option Explicit

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
    
    'save the key=value pairs
    cmdOK.Enabled = False
    Screen.MousePointer = vbHourglass
    DoEvents
    g_udtGame.strPairs = txtPairs.Text
    Set g_rsGames = g_dbGamebase.OpenRecordset("select Gemus from Games where GA_Id=" & g_udtGame.lngID, dbOpenDynaset)
    With g_rsGames
        If Not .EOF Then
            .MoveFirst
            .Edit
            !Gemus = txtPairs.Text
            .Update
        End If
        .Close
    End With
    Set g_rsGames = Nothing
    Screen.MousePointer = vbDefault
    Unload Me

End Sub


Private Sub Form_Load()

    Width = 8775 + (Width - ScaleWidth)
    Height = 5295 + (Height - ScaleHeight)

    cmdOK.Caption = g_strButtonOKText
    cmdCancel.Caption = g_strButtonCancelText

    lblName = frmMain.lblName(0)
    txtPairs = g_udtGame.strPairs
    txtPairs.SelStart = Len(txtPairs)

End Sub


